package be.iminds.ilabt.jfed.ui.cli2.instruction;

import be.iminds.ilabt.jfed.experiment.setup.ExperimentSetupConfig;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;

public abstract class InstructionWithSlice extends Instruction {
    @Nonnull protected final ExperimentSetupConfig.Slice slice;

    @JsonCreator
    public InstructionWithSlice(@JsonProperty("action") @Nonnull Action action,
                                @JsonProperty("user") @Nullable User user,
                                @JsonProperty("interactive") @Nullable Boolean interactive,
                                @JsonProperty("actionOutputs") @Nullable List<ActionOutput> actionOutputs,
                                @JsonProperty("debugOutputs") @Nullable List<DebugOutput> debugOutputs,
                                @JsonProperty("callOutputs") @Nullable List<CallOutput> callOutputs,
                                @JsonProperty("slice") ExperimentSetupConfig.Slice slice) {
        super(action, user, interactive, actionOutputs, debugOutputs, callOutputs);
        this.slice = slice == null ? new ExperimentSetupConfig.Slice() : slice;
    }

    public InstructionWithSlice(@Nonnull Action action) {
        super(action, null, null, null, null, null);
        this.slice = new ExperimentSetupConfig.Slice();
    }

    @JsonProperty
    @Nonnull
    public ExperimentSetupConfig.Slice getSlice() {
        return slice;
    }
}
